#include <stdlib.h>
#include <signal.h>
#include <math.h>
#include "mon_c.hh"

void sighandler(int, ...)
{
	exit(0);
}

int main(int argc, char **argv)
{
	signal(SIGINT, sighandler);
	if ( argc < 3 ) {
		cout << "Usage: monclnt number1 number2" << endl;
		return 1;
	}
	CORBA::Environment env;
	Monitor *monitor = Monitor::_bind(env);
	if ( env.check_exception() ) {
		cout << "Unable to bind to Monitor" << endl;
		return 1;
	}

	ComputeServer *server = monitor->get_server(env);
	if ( env.check_exception() ) {
		cout << "Unable to get ComputeServer Object." << endl;
		cout << env;
		return 1;
	}
	cout << "Answer: " << server->add(atof(argv[1]), atof(argv[2]));
	cout << endl;
	server->_release();
	monitor->_release();
	return 0;
}
