// "@(#)Module Name: dsdict.h Version:2.1 Date: 94/06/19"
#ifndef _dsdict_h
#define _dsdict_h
/****************************************************************************/
/*                                                                          */
/*  ORBeline (c)   is copyrighted by PostModern Computing Technologies, Inc */
/*                                                                          */
/*  Copyright 1993, 1994 by PostModern Computing Technologies, Inc.         */
/*                          1897 Landings Drive                             */
/*                          Mountain View, California, USA                  */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/****************************************************************************/
#include <dsset.h>
#include <dsassoc.h>

// ------------------------------------------------------------------------
// Dictionary contains a set of associations. The association contains
// the key and value pairs. When a key and value are added by addAssoc,
// a new association (DSAssoc) is created and added to the set. 
// ------------------------------------------------------------------------
class DSDictionary: public DSSet
{
	DECLARE_TRANS_CLASS(DSDictionary);
    public:
	int	compare(const NCObject& p) const;
	DSDictionary(unsigned size = 16);
	virtual ~DSDictionary();
	
	void operator=(const DSDictionary& );

	virtual DSResource *add(DSResource& );
	virtual DSAssoc	*addAssoc(DSResource& key, DSResource& value);
	virtual DSAssoc	*assocAt(const DSResource& key) const;
	virtual NCbool	includesKey(const DSResource& key) const;
	virtual NCbool	remove(const DSResource& assoc);
	virtual NCbool	removeKey(const DSResource& key); 
	virtual NCbool  removeAssoc(const DSAssoc& assoc); 
	virtual DSResource *atKey(const DSResource& key) const; // Returns value
	virtual unsigned occurrencesOf(const DSResource& val) const;
};
#endif
