#ifndef _princ_h_
#define _princ_h_


/****************************************************************************/
/*                                                                          */
/*  ORBeline (c)   is copyrighted by PostModern Computing Technologies, Inc */
/*                                                                          */
/*  Copyright 1993, 1994 by PostModern Computing Technologies, Inc.         */
/*                          1897 Landings Drive                             */
/*                          Mountain View, California, USA                  */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/****************************************************************************/


class Principal: public DSResource
{
	DECLARE_NCOBJECT_CLASS(Principal);
    private:
	String		_hostName;
	String		_loginName;
	String		_password;
	String		_userName;
	CORBA::ULong	_pid;
	CORBA::Octet 	*_user_data;
	CORBA::ULong 	_user_data_size;

    public:
	Principal(const char *login_name=(const char *)NULL, 
			const char *password= (const char *)NULL);
	Principal(const Principal& princ);
	void	operator=(const Principal& );
	void 	copyFrom(NCistream& strm);
	void	get(NCistream& strm) { copyFrom(strm); }
	void	put(NCostream& strm) const { write(strm); }

	virtual ~Principal();

	const char *hostName() const { return (const char *)_hostName; }
	const char *loginName() const { return (const char *)_loginName; }
	const char *password() const { return (const char *)_password; }
	const char *userName() const { return (const char *)_userName; }
	void loginName(const char *name) { _loginName = name; }
	void password(const char *val) { _password = val; }
	CORBA::ULong	pid() const { return _pid; }
	const CORBA::Octet *userData() const { return _user_data; }

	void userData(const CORBA::Octet *user_data, CORBA::ULong size);
	CORBA::ULong userDataSize() const { return _user_data_size; }
};



#endif
